$!/***************************************************************************
$! *                             RasMol 2.7.2.1                              *
$! *                                                                         *
$! *                                 RasMol                                  *
$! *                 Molecular Graphics Visualisation Tool                   *
$! *                              14 April 2001                              *
$! *                                                                         *
$! *                   Based on RasMol 2.6 by Roger Sayle                    *
$! * Biomolecular Structures Group, Glaxo Wellcome Research & Development,   *
$! *                      Stevenage, Hertfordshire, UK                       *
$! *         Version 2.6, August 1995, Version 2.6.4, December 1998          *
$! *                   Copyright (C) Roger Sayle 1992-1999                   *
$! *                                                                         *
$! *                          and Based on Mods by                           *
$! *Author             Version, Date             Copyright                   *
$! *Arne Mueller       RasMol 2.6x1   May 98     (C) Arne Mueller 1998       *
$! *Gary Grossman and  RasMol 2.5-ucb Nov 95     (C) UC Regents/ModularCHEM  *
$! *Marco Molinaro     RasMol 2.6-ucb Nov 96         Consortium 1995, 1996   *
$! *                                                                         *
$! *Philippe Valadon   RasTop 1.3     Aug 00     (C) Philippe Valadon 2000   *
$! *                                                                         *
$! *Herbert J.         RasMol 2.7.0   Mar 99     (C) Herbert J. Bernstein    * 
$! *Bernstein          RasMol 2.7.1   Jun 99         1998-2001               *
$! *                   RasMol 2.7.1.1 Jan 01                                 *
$! *                   RasMol 2.7.2   Aug 00                                 *
$! *                   RasMol 2.7.2.1 Apr 01                                 *
$! *                                                                         *
$! *                    and Incorporating Translations by                    *
$! *  Author                               Item                      Language*
$! *  Isabel Servn Martnez,                                                *
$! *  Jos Miguel Fernndez Fernndez      2.6   Manual              Spanish *
$! *  Jos Miguel Fernndez Fernndez      2.7.1 Manual              Spanish *
$! *  Fernando Gabriel Ranea               2.7.1 menus and messages  Spanish *
$! *  Jean-Pierre Demailly                 2.7.1 menus and messages  French  *
$! *  Giuseppe Martini, Giovanni Paolella, 2.7.1 menus and messages          *
$! *  A. Davassi, M. Masullo, C. Liotto    2.7.1 help file           Italian *
$! *                                                                         *
$! *                             This Release by                             *
$! * Herbert J. Bernstein, Bernstein + Sons, P.O. Box 177, Bellport, NY, USA *
$! *                       yaya@bernstein-plus-sons.com                      *
$! *               Copyright(C) Herbert J. Bernstein 1998-2001               *
$! *                                                                         *
$! * Please read the file NOTICE for important notices which apply to this   *
$! * package. If you are not going to make changes to RasMol, you are not    *
$! * only permitted to freely make copies and distribute them, you are       *
$! * encouraged to do so, provided you do the following:                     *
$! *   * 1. Either include the complete documentation, especially the file   *
$! *     NOTICE, with what you distribute or provide a clear indication      *
$! *     where people can get a copy of the documentation; and               *
$! *   * 2. Please give credit where credit is due citing the version and    *
$! *     original authors properly; and                                      *
$! *   * 3. Please do not give anyone the impression that the original       *
$! *     authors are providing a warranty of any kind.                       *
$! *                                                                         *
$! * If you would like to use major pieces of RasMol in some other program,  *
$! * make modifications to RasMol, or in some other way make what a lawyer   *
$! * would call a "derived work", you are not only permitted to do so, you   *
$! * are encouraged to do so. In addition to the things we discussed above,  *
$! * please do the following:                                                *
$! *   * 4. Please explain in your documentation how what you did differs    *
$! *     from this version of RasMol; and                                    *
$! *   * 5. Please make your modified source code available.                 *
$! *                                                                         *
$! * This version of RasMol is not in the public domain, but it is given     *
$! * freely to the community in the hopes of advancing science. If you make  *
$! * changes, please make them in a responsible manner, and please offer us  *
$! * the opportunity to include those changes in future versions of RasMol.  *
$! ***************************************************************************/
$!
$! BUILD_ALL.COM
$! VMS Compilation Script, ALL VERSIONS
$! RasMol v2.7.1
$!
$! General setup
$!
$ If F$Trnlnm ("X11") .eqs. "" Then Define X11 DECW$Include
$ If F$Trnlnm ("SYS") .eqs. "" Then Define Sys Sys$Share
$!
$! Just some general constants...
$!
$ true  = 1
$ false = 0
$!
$!
$! Setup variables holding "config" information
$!
$ Make    = ""
$ v7          = f$extract(1,1,f$getsyi("version")) .ges. "7"
$ resnum_all  = "8,16,24,32"
$ resalph_all = "EIGHTBIT,SIXTEENBIT,THIRTYTWOBIT,THIRTYTWOBIT"
$ resnum      = ""
$ resalph     = ""
$ shmdef      = ""
$ name        = "Rasmol"
$ version     = "?.?"
$!
$! Check for MMK/MMS
$!
$ If F$Search ("Sys$System:MMS.EXE") .nes. "" Then Make = "MMS"
$ If F$Type (MMK) .eqs. "STRING" Then Make = "MMK"
$!
$! Find out Rasmol version
$!
$ write sys$output "Getting the version number"
$ open/read in rasmol.h
$vloop:
$ read/end=vdone in rec
$ if (f$element(1," " ,rec) .nes. "VERSION") then goto vloop
$ version = f$element(1,"""",rec)
$vdone:
$ close in
$ 
$!
$! Check if xdpyinfo is available. If yes create a file with the current 
$! display properties for later usage. 
$!
$ if f$search("xdpy.txt") .nes. "" then delete/noconf/nolog xdpy.txt;*
$ if f$search("DECW$UTILS:XDPYINFO.EXE") .nes. "" then - 
       xdpy_cmd = "$DECW$UTILS:XDPYINFO.EXE"
$ if f$type(XDPYINFO) .eqs. "STRING" then xdpy_cmd = "''xdpyinfo'"
$ if xdpy_cmd .nes. "" 
$ then
$   define/user sys$output xdpy.txt
$   define/user sys$error nla0:
$   xdpy_cmd
$ endif
$!
$! Process compilation options
$!
$!
$! First pass: Process options concerning display type
$!
$ p1 = f$edit(p1,"upcase,collapse")
$ if (p1 .eqs. "") .or. (p1 .eqs. "ALL") 
$ then
$   resnum = resnum_all
$   resalph = resalph_all
$ else
$   if (p1 .eqs. "AUTO")
$   then
$!
$!  This only works in case we've got information from a previous xdpyinfo
$!  invocation
$!
$     if f$search("XDPY.TXT") .nes. "" 
$     then 
$       search/out=planes.txt. xdpy.txt depth:,planes/match=and
$       sort/nodup planes.txt planes.txt
$       open plane_in planes.txt
$       read plane_in line
$       close plane_in
$       req_depth = f$element(1, " ", f$edit(line,"COMPRESS,TRIM"))     
$       gosub check_depth
$       write sys$output "Will build for ''resnum'-Bit display"
$     else
$       gosub auto_end
$     endif
$   else
$!
$!    List processing
$!
$     num = 0
$P1_LOOP:
$     req_depth = f$element(num, ",", p1)
$     if req_depth .eqs. "," then goto P1_END
$     num = num + 1
$     gosub check_depth
$     goto p1_loop
$P1_END:
$   endif
$ endif
$ if (resnum .eqs. "") 
$ then
$   write sys$output "Could not process option ''p1'"
$   type sys$input

Valid values for this parameter are:

ALL     - Build 8, 16 and 32-Bit display versions of Rasmol (default)
AUTO    - Detect display depth of currently running Xserver and build fitting 
          Rasmol version
8,16,32 - Coma separated list of Rasmol versions to build (e.g. 8,32 will build
          Rasmol for 8 and 32-Bit displays)
	  
Exiting now...
$   exit	  
$ endif
$!
$! Second pass: Build Rasmol with support for MIT-SHM server extension
$!
$ p2 = f$edit(p2,"upcase,collapse")
$ if (p2 .eqs. "") .or. (p2 .eqs. "NOMITSHM") 
$ then
$   shmdef = ",NOMITSHM"
$ else
$   if (p2 .eqs. "MITSHM")
$   then
$     shmdef = ",MITSHM"
$   else
$     if (p2 .eqs. "AUTO")
$     then
$!
$!  This only works in case we've got information from a previous xdpyinfo
$!  invocation
$!
$       if f$search("XDPY.TXT") .nes. "" 
$       then 
$         search/noout xdpy.txt mit-shm
$         if ($status .eqs. "%X00000001") ! i.e. server supports MIT-SHM
$         then
$!
$!          We might have been fooled by a server running on a remote 
$!          display, so check if the necessary header files are there
$!
$           if f$search("x11:shm.h") .nes. "" 
$           then
$             write sys$output  - 
                "Found both server and programming support for MIT-SHM"
$             shmdef = ",MITSHM"
$           else
$             write sys$output "While your server supports MIT-SHM, " 
$             write sys$output "the neccessary includes are missing."
$             shmdef = ",NOMITSHM"
$           endif
$         else
$           write sys$output "Your server does not support MIT-SHM"
$           shmdef = ",NOMITSHM" 
$         endif
$       endif 
$     else
$       goto auto_end
$     endif
$   endif
$ endif
$ if (shmdef .eqs. "") 
$ then
$   write sys$output "Could not process option ''p2'"
$   type sys$input

Valid values for this parameter are:

NOMITSHM - Build Rasmol without support for the MIT-SHM Xserver extension 
           (default)
MITSHM   - Build Rasmol with support for the MIT-SHM Xserver extension	  
AUTO     - Detect it current Xserver supports MIT-SHM and if yes build
           a version of Rasmol
Exiting now...
$   exit	  
$ endif
$ src = "rasmol,molecule,infile,transfor,cmndline,command,abstree,render," + -
        "repres,x11win,pixutils,outfile,script,tokens,cif_fract,cif," + -
	"cif_ctonum,cif_stx,wbrotate,vector,langsel,multiple"
$ if .not.v7 then src = src + ",string_case,rint"	
$!
$! Build the option-file
$!
$ open/write optf rasmol.opt
$ num = 0
$OPTF_LOOP:
$   file = f$element(num,",",src)
$   if file .eqs. "," then goto optf_end
$   write optf "''file'.obj"
$   num = num + 1
$   goto optf_loop
$OPTF_END:
$ write optf "Identification=""''name' ''version'"""
$ write optf "sys$share:decw$xlibshr/share"
$ write optf "sys$share:decw$xextlibshr/share"
$ close optf
$!
$ if f$search("rasmol*.exe") .nes. "" then del rasmol*.exe;*
$ copy [.vms]rasmol.h rasmol.h
$ num = 0
$RES_LOOP:
$   resn = f$element(num,",",resnum)
$   resa = f$element(num,",",resalph)
$   if (resn .eqs. ",") .or. (resa .eqs. ",") then goto res_end
$   target = "rasmol_''resn'bit.exe"
$   write sys$output "Building ''target'..."
$   cdefs = "/define=(''resa'''shmdef')"
$   num = num + 1
$   if f$search("*.obj") .nes. "" then del *.obj;*
$   gosub build_rasmol
$   goto res_loop
$RES_END:
$ set prot=w:r rasmol.hlp
$ if f$search("*.obj")      .nes. "" then delete  *.obj;*
$ if f$search("xdpy.txt")   .nes. "" then delete xdpy.txt;*
$ if f$search("planes.txt") .nes. "" then delete planes.txt;*
$ exit
$!
$! Actually compile/link rasmol
$!
$BUILD_RASMOL:
$ IF Make .nes. ""
$ THEN
$   gosub crea_mms
$   write sys$output "Make ''name' with ''Make' "
$   write sys$output ""
$   'Make'  /IGNORE=WARNING
$   rename rasmol.exe 'target'
$   purge/nolog descrip.mms
$ ELSE
$   fnum = 0
$CC_LOOP:
$     file = f$element(fnum,",",src)
$     if file .eqs. "," then goto cc_end
$     write sys$output f$fao("!_cc/optimize !AS !AS.c",cdefs,file)
$     cc/optimize 'cdefs' 'file'.c
$     fnum = fnum + 1
$     goto cc_loop
$CC_END:
$     write sys$output f$fao("!_Linking !AS", target)
$     link/exe='target' [.vms]rasmol.opt/opt
$     set prot=w:re 'target'
$ endif
$ return
$!
$! Check if a given value is a valid display depth for Rasmol
$!
$CHECK_DEPTH:
$ i = 0
$DEPTH_LOOP:
$ test_depth = f$element(i, ",", resnum_all)
$ if test_depth .eqs. "," then goto end_depth_loop
$ if test_depth .eqs. req_depth
$ then
$   resnum  = resnum + "," + req_depth 
$   resalph = resalph + "," + f$element(i, ",", resalph_all)
$ endif
$ i = i + 1
$ goto depth_loop
$END_DEPTH_LOOP:
$ resnum = resnum - ","
$ resalph = resalph - "," 
$ return
$!
$!  Inform that Auto detection only works if xdpyinfo is available
$!
$AUTO_END:
$ type sys$input
Auto detection is only supported in case the program xdpyinfo is available
on your system. The procedure checked for this in the directory decw$utils as 
well as for a symbol pointing to this program without success.

In case you want it can be installed as part of the Compaq DECwindows 
installation or retrived separatly from 
http://www.decus.de:8080/www/vms/sw/xdpyinfo.htmlx

Exiting now...
$ exit
$ return
$!------------------------------------------------------------------------------
$!
$! If MMS/MMK are available dump out the descrip.mms if required
$!
$CREA_MMS:
$ write sys$output "Creating descrip.mms..."
$ create descrip.mms
$ open/append out descrip.mms
$ copy sys$input: out
$ deck
!###########################################################################
!#                              RasMol 2.7.1                               # 
!#                                                                         #
!#                                 RasMol                                  #
!#                 Molecular Graphics Visualisation Tool                   #
!#                              22 June 1999                               #
!#                                                                         #
!#                   Based on RasMol 2.6 by Roger Sayle                    #
!# Biomolecular Structures Group, Glaxo Wellcome Research & Development,   #
!#                      Stevenage, Hertfordshire, UK                       #
!#         Version 2.6, August 1995, Version 2.6.4, December 1998          #
!#                   Copyright (C) Roger Sayle 1992-1999                   #
!#                                                                         #
!#                  and Based on Mods by Arne Mueller                      #
!#                      Version 2.6x1, May 1998                            #
!#                   Copyright (C) Arne Mueller 1998                       #
!#                                                                         #
!#           Version 2.7.0, 2.7.1 Mods by Herbert J. Bernstein             #
!#           Bernstein + Sons, P.O. Box 177, Bellport, NY, USA             #
!#                      yaya@bernstein-plus-sons.com                       #
!#                    2.7.0 March 1999, 2.7.1 June 1999                    #
!#              Copyright (C) Herbert J. Bernstein 1998-1999               #
!#                                                                         #
!# Please read the file NOTICE for important notices which apply to this   #
!# package. If you are not going to make changes to RasMol, you are not    # 
!# only permitted to freely make copies and distribute them, you are       # 
!# encouraged to do so, provided you do the following:                     #
!#   * 1. Either include the complete documentation, especially the file   #
!#     NOTICE, with what you distribute or provide a clear indication      #
!#     where people can get a copy of the documentation; and               #
!#   * 2. Please give credit where credit is due citing the version and    # 
!#     original authors properly; and                                      # 
!#   * 3. Please do not give anyone the impression that the original       # 
!#     authors are providing a warranty of any kind.                       #
!#                                                                         #
!# If you would like to use major pieces of RasMol in some other program,  #
!# make modifications to RasMol, or in some other way make what a lawyer   #
!# would call a "derived work", you are not only permitted to do so, you   #
!# are encouraged to do so. In addition to the things we discussed above,  #
!# please do the following:                                                #
!#   * 4. Please explain in your documentation how what you did differs    #
!#     from this version of RasMol; and                                    #
!#   * 5. Please make your modified source code available.                 #
!#                                                                         #
!# This version of RasMol is not in the public domain, but it is given     #
!# freely to the community in the hopes of advancing science. If you make  #
!# changes, please make them in a responsible manner, and please offer us  #
!# the opportunity to include those changes in future versions of RasMol.  #
!###########################################################################
!#
CC = CC
LINK = LINK

LFLAGS = 
$ eod
$ write out "CFLAGS = /optimize", cdefs 
$ copy sys$input: out
$ deck

OBJS = rasmol.obj, molecule.obj, infile.obj, transfor.obj, command.obj, -
         abstree.obj, render.obj, repres.obj, x11win.obj, pixutils.obj, -
         outfile.obj, script.obj, cif.obj, cmndline.obj, tokens.obj -
         cif_fract.obj, cif_ctonum.obj, cif_stx.obj, string_case.obj -
         multiple.obj, vector.obj,  wbrotate.obj, langsel.obj

$ eod
$ if .not.v7 then  - 
    write out = OBJS = $(OBJS)  + ",string_case.obj, rint.obj"	
$ copy sys$input: out
rasmol : $(OBJS)
         $(LINK) /exec=rasmol $(LFLAGS) rasmol/opt

rasmol.obj :   rasmol.c, rasmol.h, molecule.h, transfor.h, command.h, -
               infile.h, abstree.h, render.h, graphics.h, pixutils.h, -
               outfile.h, repres.h,  cmndline.h
               $(CC) $(CFLAGS) rasmol.c

molecule.obj : molecule.c, molecule.h, rasmol.h, abstree.h, transfor.h, -
               render.h, command.h string_case.h
               $(CC) $(CFLAGS) molecule.c

infile.obj :   infile.c, infile.h, rasmol.h, molecule.h, abstree.h, -
               command.h, transfor.h, cif.h, cif_fract.h
               $(CC) $(CFLAGS) infile.c

transfor.obj : transfor.c, transfor.h, rasmol.h, molecule.h, command.h, -
               abstree.h, render.h, graphics.h, repres.h
               $(CC) $(CFLAGS) transfor.c

cmndline.obj : cmndline.c, cmndline.h, rasmol.h, molecule.h, command.h, -
               render.h, graphics.h
               $(CC) $(CFLAGS) cmndline.c

command.obj :  command.c, command.h, rasmol.h, tokens.h, abstree.h, -
               molecule.h, transfor.h, render.h, graphics.h, pixutils.h, -
               outfile.h, infile.h, script.h string_case.h
               $(CC) $(CFLAGS) command.c

abstree.obj :  abstree.c, abstree.h, rasmol.h, molecule.h
               $(CC) $(CFLAGS) abstree.c

render.obj :   render.c, render.h, rasmol.h, molecule.h, transfor.h, -
               command.h, abstree.h, graphics.h, pixutils.h
               $(CC) $(CFLAGS) render.c

repres.obj :   repres.c, repres.h, rasmol.h
               $(CC) $(CFLAGS) repres.c

x11win.obj :   x11win.c, graphics.h, rasmol.h, bitmaps.h, command.h
               $(CC) $(CFLAGS) x11win.c

pixutils.obj : pixutils.c, pixutils.h, rasmol.h, font.h, molecule.h, -
               transfor.h,  render.h, graphics.h, abstree.h
               $(CC) $(CFLAGS) pixutils.c

outfile.obj :  outfile.c, outfile.h, rasmol.h, molecule.h, command.h, -
               abstree.h, transfor.h, render.h, graphics.h, pixutils.h, -
               script.h, repres.h
               $(CC) $(CFLAGS) outfile.c

script.obj :   script.c, script.h, rasmol.h, molecule.h, command.h, -
               abstree.h, transfor.h, render.h, graphics.h, pixutils.h, -
               repres.h
               $(CC) $(CFLAGS) script.c

tokens.obj :   tokens.c, tokens.h
               $(CC) $(CFLAGS) tokens.c

cif_fract.obj : cif_fract.c, rasmol.h
               $(CC) $(CFLAGS) cif_fract.c

cif.obj :       cif.c, cif.h, rasmol.h, molecule.h string_case.h
               $(CC) $(CFLAGS) cif.c

cif_ctonum.obj : cif_ctonum.c, cif_ctonum.h, rasmol.h string_case.h
               $(CC) $(CFLAGS) cif_ctonum.c

cif_stx.obj :  cif_stx.c, cif.h
               $(CC) $(CFLAGS) cif_stx.c

string_case.obj : string_case.c
               $(CC) $(CFLAGS) string_case.c

langsel.obj :   langsel.c, rasmol.h, graphics.h, langsel.h
               $(CC) $(CFLAGS) langsel.c

multiple.obj : multiple.c, rasmol.h,   command.h, tokens.h, molecule.h, -
               abstree.h,  transfor.h, render.h,  repres.h, graphics.h, -
               pixutils.h, multiple.h, outfile.h, script.h, vector.h, -
               wbrotate.h, langsel.h
               $(CC) $(CFLAGS) multiple.c

vector.obj :   vector.c, rasmol.h, command.h, tokens.h, molecule.h, -
               abstree.h, transfor.h, vector.h multiple.h 
               $(CC) $(CFLAGS) vector.c

wbrotate.obj : wbrotate.c, rasmol.h, molecule.h, abstree.h, transfor.h, -
               command.h, render.h, repres.h, graphics.h, multiple.h, -
               vector.h, wbrotate.h
               $(CC) $(CFLAGS) wbrotate.c

rint.obj :     rint.c
               $(CC) $(CFLAGS) rint.c

$ eod
$ close out
$ return
$!------------------------------------------------------------------------------
